!---------------------------------------------------------------------- 
!---------------------------------------------------------------------- 
!        Standard repressilator model (Elowitz et al 2000)
!---------------------------------------------------------------------- 
!----------------------------------------------------------------------
!

 SUBROUTINE FUNC(NDIM,U,ICP,PAR,IJAC,F,DFDU,DFDP)
!--------- ---- 

    IMPLICIT NONE
    INTEGER, INTENT(IN) :: NDIM, IJAC, ICP(*)
    DOUBLE PRECISION, INTENT(IN) :: U(NDIM), PAR(*)
    DOUBLE PRECISION, INTENT(OUT) :: F(NDIM), DFDU(NDIM,*), DFDP(NDIM,*)

    ! Variables
    DOUBLE PRECISION :: x1, x2, x3
    ! Parameters
    DOUBLE PRECISION :: g1, a, b, k, h

    ! Definition of variables
    x1 = U(1)
    x2 = U(2)
    x3 = U(3)

    ! Definition of parameters
    g1 = PAR(1)
    a = PAR(2)
    b = PAR(3)
    k = PAR(4)
    h = PAR(5)


    F(1) = b + g1/(1 + a * x2**h) - k * x1
    F(2) = b + 0.05/(1 + a * x3**3) - k * x2
    F(3) = b + 0.05/(1 + a * x1**3) - k * x3

 END SUBROUTINE FUNC

!---------------------------------------------------------------------- 
 SUBROUTINE STPNT(NDIM,U,PAR,T)
!--------- ---- 

    IMPLICIT NONE
    INTEGER, INTENT(IN) :: NDIM
    DOUBLE PRECISION, INTENT(IN) :: T
    DOUBLE PRECISION, INTENT(OUT) :: U(NDIM), PAR(*)

    U(1:3)=(/0.58469,0.87298,0.45578/)


    ! System parameters

    PAR(1) = 0.2
    PAR(2) = 50.0
    PAR(3) = 1E-5
    PAR(4) = 0.01
    PAR(5) = 3.0


 END SUBROUTINE STPNT

!---------------------------------------------------------------------- 
 SUBROUTINE PVLS(NDIM,U,PAR)
!     ---------------
      IMPLICIT NONE
      INTEGER, INTENT(IN) :: NDIM
      DOUBLE PRECISION, INTENT(IN) :: U(NDIM)
      DOUBLE PRECISION, INTENT(INOUT) :: PAR(*)

      DOUBLE PRECISION, EXTERNAL :: GETP
      INTEGER NDX,NCOL,NTST

       PAR(6)=GETP('MIN',1,U)
!       PAR(5)=GETP('MIN',2,U)
!       PAR(6)=GETP('MIN',3,U)

!---------------------------------------------------------------------- 
 END SUBROUTINE PVLS

!---------------------------------------------------------------------- 
 SUBROUTINE BCND
 END SUBROUTINE BCND

!---------------------------------------------------------------------- 
 SUBROUTINE ICND 
 END SUBROUTINE ICND

!----------------------------------------------------------------------
 SUBROUTINE FOPT 
 END SUBROUTINE FOPT
